a0e06ed0768f65241b59cfdec7b0f6b833580c53
1#!/bin/sh
2#
3# Copyright (c) 2005 Linus Torvalds
4#
5
6OPTIONS_KEEPDASHDASH=
7OPTIONS_SPEC="\
8git-repack [options]
9--
10a pack everything in a single pack
11A same as -a, and keep unreachable objects too
12d remove redundant packs, and run git-prune-packed
13f pass --no-reuse-delta to git-pack-objects
14q,quiet be quiet
15l pass --local to git-pack-objects
16 Packing constraints
17window= size of the window used for delta compression
18window-memory= same as the above, but limit memory size instead of entries count
19depth= limits the maximum delta depth
20max-pack-size= maximum size of each packfile
21"
22SUBDIRECTORY_OK='Yes'
23. git-sh-setup
24
25no_update_info= all_into_one= remove_redundant= keep_unreachable=
26local= quiet= no_reuse= extra=
27while test $# != 0
28do
29 case "$1" in
30 -n) no_update_info=t ;;
31 -a) all_into_one=t ;;
32 -A) all_into_one=t
33 keep_unreachable=t ;;
34 -d) remove_redundant=t ;;
35 -q) quiet=-q ;;
36 -f) no_reuse=--no-reuse-object ;;
37 -l) local=--local ;;
38 --max-pack-size|--window|--window-memory|--depth)
39 extra="$extra $1=$2"; shift ;;
40 --) shift; break;;
41 *) usage ;;
42 esac
43 shift
44done
45
46# Later we will default repack.UseDeltaBaseOffset to true
47default_dbo=false
48
49case "`git config --bool repack.usedeltabaseoffset ||
50 echo $default_dbo`" in
51true)
52 extra="$extra --delta-base-offset" ;;
53esac
54
55PACKDIR="$GIT_OBJECT_DIRECTORY/pack"
56PACKTMP="$GIT_OBJECT_DIRECTORY/.tmp-$$-pack"
57rm -f "$PACKTMP"-*
58trap 'rm -f "$PACKTMP"-*' 0 1 2 3 15
59
60# There will be more repacking strategies to come...
61case ",$all_into_one," in
62,,)
63 args='--unpacked --incremental'
64 ;;
65,t,)
66 if [ -d "$PACKDIR" ]; then
67 for e in `cd "$PACKDIR" && find . -type f -name '*.pack' \
68 | sed -e 's/^\.\///' -e 's/\.pack$//'`
69 do
70 if [ -e "$PACKDIR/$e.keep" ]; then
71 : keep
72 else
73 args="$args --unpacked=$e.pack"
74 existing="$existing $e"
75 fi
76 done
77 fi
78 if test -z "$args"
79 then
80 args='--unpacked --incremental'
81 fi
82 ;;
83esac
84
85args="$args $local $quiet $no_reuse$extra"
86names=$(git pack-objects --non-empty --all --reflog $args </dev/null "$PACKTMP") ||
87 exit 1
88if [ -z "$names" ]; then
89 if test -z "$quiet"; then
90 echo Nothing new to pack.
91 fi
92fi
93for name in $names ; do
94 fullbases="$fullbases pack-$name"
95 chmod a-w "$PACKTMP-$name.pack"
96 chmod a-w "$PACKTMP-$name.idx"
97 mkdir -p "$PACKDIR" || exit
98
99 for sfx in pack idx
100 do
101 if test -f "$PACKDIR/pack-$name.$sfx"
102 then
103 mv -f "$PACKDIR/pack-$name.$sfx" \
104 "$PACKDIR/old-pack-$name.$sfx"
105 fi
106 done &&
107 mv -f "$PACKTMP-$name.pack" "$PACKDIR/pack-$name.pack" &&
108 mv -f "$PACKTMP-$name.idx" "$PACKDIR/pack-$name.idx" &&
109 test -f "$PACKDIR/pack-$name.pack" &&
110 test -f "$PACKDIR/pack-$name.idx" || {
111 echo >&2 "Couldn't replace the existing pack with updated one."
112 echo >&2 "The original set of packs have been saved as"
113 echo >&2 "old-pack-$name.{pack,idx} in $PACKDIR."
114 exit 1
115 }
116 rm -f "$PACKDIR/old-pack-$name.pack" "$PACKDIR/old-pack-$name.idx"
117done
118
119if test "$remove_redundant" = t
120then
121 # We know $existing are all redundant.
122 if [ -n "$existing" ]
123 then
124 sync
125 ( cd "$PACKDIR" &&
126 for e in $existing
127 do
128 case " $fullbases " in
129 *" $e "*) ;;
130 *)
131 rm -f "$e.idx" "$e.keep"
132 if test -n "$keep_unreachable" &&
133 test -f "$e.pack"
134 then
135 git unpack-objects < "$e.pack" || {
136 echo >&2 "Failed unpacking unreachable objects from redundant pack file $e.pack"
137 exit 1
138 }
139 fi
140 rm -f "$e.pack"
141 ;;
142 esac
143 done
144 )
145 fi
146 git prune-packed $quiet
147fi
148
149case "$no_update_info" in
150t) : ;;
151*) git-update-server-info ;;
152esac